// Generated by CoffeeScript 1.6.3
/* Copyright Information  
	# @author	Tim Düsterhus  
	# @copyright	2010-2013 Tim Düsterhus  
	# @license	Creative Commons Attribution-NonCommercial-ShareAlike <http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode>  
	# @package	be.bastelstu.chat
*/


(function() {
  (function($, window) {
    "use strict";
    var Chat, addListener, autocomplete, chatSession, closePrivateChannel, console, currentRoom, errorVisible, events, freeTheFish, getMessages, handleMessages, handleUsers, hideInputError, init, initialized, inputErrorHidingTimer, insertText, isActive, join, lastMessage, loading, newMessageCount, notify, openChannel, openPrivateChannel, pe, refreshRoomList, remainingFailures, removeListener, scrollUpNotifications, showError, showInputError, userList, v;
    console = {
      log: function(message) {
        return window.console.log("[be.bastelstu.Chat] " + message);
      },
      warn: function(message) {
        return window.console.warn("[be.bastelstu.Chat] " + message);
      },
      error: function(message) {
        return window.console.error("[be.bastelstu.Chat] " + message);
      }
    };
    isActive = true;
    newMessageCount = 0;
    scrollUpNotifications = false;
    chatSession = Date.now();
    userList = {
      current: {},
      allTime: {}
    };
    currentRoom = {};
    errorVisible = false;
    inputErrorHidingTimer = null;
    lastMessage = null;
    openChannel = 0;
    remainingFailures = 3;
    events = {
      newMessage: $.Callbacks(),
      userMenu: $.Callbacks(),
      submit: $.Callbacks()
    };
    pe = {
      getMessages: null,
      refreshRoomList: null,
      fish: null
    };
    loading = false;
    autocomplete = {
      offset: 0,
      value: null,
      caret: 0
    };
    v = {
      titleTemplate: null,
      messageTemplate: null,
      userTemplate: null,
      config: null
    };
    initialized = false;
    init = function(roomID, config, titleTemplate, messageTemplate, userTemplate) {
      if (initialized) {
        return false;
      }
      initialized = true;
      v.config = config;
      v.titleTemplate = titleTemplate;
      v.messageTemplate = messageTemplate;
      v.userTemplate = userTemplate;
      console.log('Initializing');
      $(window).focus(function() {
        document.title = v.titleTemplate.fetch(currentRoom);
        newMessageCount = 0;
        return isActive = true;
      });
      $(window).blur(function() {
        return isActive = false;
      });
      $(window).on('beforeunload', function() {
        if (errorVisible) {
          return void 0;
        }
        new WCF.Action.Proxy({
          autoSend: true,
          data: {
            actionName: 'leave',
            className: 'chat\\data\\room\\RoomAction'
          },
          showLoadingOverlay: false,
          async: false,
          suppressErrors: true
        });
        return void 0;
      });
      $('#smilies').on('click', 'img', function() {
        return insertText(" " + ($(this).attr('alt')) + " ");
      });
      $('#privateChannelsMenu').on('click', '.privateChannel', function() {
        return openPrivateChannel($(this).data('privateChannelID'));
      });
      $('#timsChatForm').submit(function(event) {
        var text;
        event.preventDefault();
        text = $('#timsChatInput').val().trim();
        $('#timsChatInput').val('').focus().keyup();
        if (text.length === 0) {
          return false;
        }
        if (openChannel !== 0) {
          text = "/whisper " + userList.allTime[openChannel].username + ", " + text;
        }
        if (text.toLowerCase() === '/free the fish') {
          freeTheFish();
        }
        text = (function(text) {
          var obj;
          obj = {
            text: text
          };
          events.submit.fire(obj);
          return obj.text;
        })(text);
        return new WCF.Action.Proxy({
          autoSend: true,
          data: {
            actionName: 'send',
            className: 'chat\\data\\message\\MessageAction',
            parameters: {
              text: text,
              enableSmilies: $('#timsChatSmilies').data('status')
            }
          },
          showLoadingOverlay: false,
          success: function() {
            hideInputError();
            return getMessages();
          },
          failure: function(data) {
            var _ref, _ref1, _ref2;
            if (!(((data != null ? (_ref = data.returnValues) != null ? _ref.errorType : void 0 : void 0) != null) || ((data != null ? data.message : void 0) != null))) {
              return true;
            }
            showInputError((_ref1 = (data != null ? (_ref2 = data.returnValues) != null ? _ref2.errorType : void 0 : void 0)) != null ? _ref1 : data.message);
            return false;
          }
        });
      });
      $('#timsChatInput').keydown(function(event) {
        var afterComplete, beforeCaret, beforeComplete, command, commands, input, lastSpace, nextSpace, regex, toComplete, user, userID, users, _ref;
        if (event.keyCode === $.ui.keyCode.TAB) {
          event.preventDefault();
          input = $(this);
          if (autocomplete.value == null) {
            autocomplete.value = input.val();
          }
          if (autocomplete.caret == null) {
            autocomplete.caret = input.getCaret();
          }
          beforeCaret = autocomplete.value.substring(0, autocomplete.caret);
          lastSpace = beforeCaret.lastIndexOf(' ');
          beforeComplete = autocomplete.value.substring(0, lastSpace + 1);
          toComplete = autocomplete.value.substring(lastSpace + 1);
          nextSpace = toComplete.indexOf(' ');
          if (nextSpace === -1) {
            afterComplete = '';
          } else {
            afterComplete = toComplete.substring(nextSpace + 1);
            toComplete = toComplete.substring(0, nextSpace);
          }
          if (toComplete.length === 0) {
            return;
          }
          console.log("Autocompleting '" + toComplete + "'");
          if (beforeComplete === '' && (toComplete.substring(0, 1)) === '/') {
            regex = new RegExp("^" + (WCF.String.escapeRegExp(toComplete.substring(1))), "i");
            commands = (function() {
              var _i, _len, _ref, _results;
              _ref = v.config.installedCommands;
              _results = [];
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                command = _ref[_i];
                if (regex.test(command)) {
                  _results.push(command);
                }
              }
              return _results;
            })();
            if (commands.length !== 0) {
              toComplete = '/' + commands[autocomplete.offset++ % commands.length] + ' ';
            }
          } else {
            regex = new RegExp("^" + (WCF.String.escapeRegExp(toComplete)), "i");
            users = [];
            _ref = userList.current;
            for (userID in _ref) {
              user = _ref[userID];
              if (regex.test(user.username)) {
                users.push(user.username);
              }
            }
            if (users.length !== 0) {
              toComplete = users[autocomplete.offset++ % users.length] + ', ';
            }
          }
          input.val("" + beforeComplete + toComplete + afterComplete);
          return input.setCaret((beforeComplete + toComplete).length);
        } else {
          return $('#timsChatInput').click();
        }
      });
      $('#timsChatInput').click(function() {
        return autocomplete = {
          offset: 0,
          value: null,
          caret: null
        };
      });
      $('#timsChatRoomList button').click(function() {
        return refreshRoomList();
      });
      $('#timsChatClear').click(function(event) {
        event.preventDefault();
        $('.timsChatMessageContainer.active .timsChatMessage').remove();
        return $('.timsChatMessageContainer.active').scrollTop($('.timsChatMessageContainer.active').prop('scrollHeight'));
      });
      $('.timsChatToggle').click(function(event) {
        var element;
        element = $(this);
        if (element.data('status') === 1) {
          element.data('status', 0);
          element.removeClass('active');
          element.attr('title', element.data('enableMessage'));
        } else {
          element.data('status', 1);
          element.addClass('active');
          element.attr('title', element.data('disableMessage'));
        }
        return $('#timsChatInput').focus();
      });
      $('#timsChatSmilies').click(function(event) {
        if ($(this).data('status')) {
          return $('#smilies').removeClass('disabled');
        } else {
          return $('#smilies').addClass('disabled');
        }
      });
      $('#timsChatFullscreen').click(function(event) {
        $('.dropdownMenu').data('orientationX', '');
        if ($(this).data('status')) {
          return $('html').addClass('fullscreen');
        } else {
          return $('html').removeClass('fullscreen');
        }
      });
      $('#timsChatMark').click(function(event) {
        if ($(this).data('status')) {
          return $('.timsChatMessageContainer').addClass('markEnabled');
        } else {
          return $('.timsChatMessageContainer').removeClass('markEnabled');
        }
      });
      $('.jsTopicCloser').on('click', function() {
        if ($('.timsChatMessageContainer.active').data('userID') === 0) {
          return $('#timsChatTopic').addClass('hidden');
        } else {
          return closePrivateChannel($('.timsChatMessageContainer.active').data('userID'));
        }
      });
      $(document).on('click', '.timsChatMessage :checkbox', function(event) {
        if ($(this).is(':checked')) {
          return $(this).parents('.timsChatMessage').addClass('jsMarked');
        } else {
          return $(this).parents('.timsChatMessage').removeClass('jsMarked');
        }
      });
      $('#timsChatAutoscroll').click(function(event) {
        if ($('#timsChatAutoscroll').data('status')) {
          return $('.timsChatMessageContainer.active').scrollTop($('.timsChatMessageContainer.active').prop('scrollHeight'));
        }
      });
      $('.timsChatMessageContainer.active').on('scroll', function(event) {
        var element, height, scrollHeight, scrollTop;
        element = $(this);
        scrollTop = element.scrollTop();
        scrollHeight = element.prop('scrollHeight');
        height = element.height();
        if (scrollTop < scrollHeight - height - 25) {
          if ($('#timsChatAutoscroll').data('status') === 1) {
            scrollUpNotifications = true;
            $('#timsChatAutoscroll').click();
          }
        }
        if (scrollTop > scrollHeight - height - 10) {
          if ($('#timsChatAutoscroll').data('status') === 0) {
            scrollUpNotifications = false;
            $(this).removeClass('notification');
            return $('#timsChatAutoscroll').click();
          }
        }
      });
      try {
        window.localStorage.setItem('be.bastelstu.chat.session', chatSession);
        $(window).on('storage', function(event) {
          if (event.originalEvent.key === 'be.bastelstu.chat.session') {
            if (parseInt(event.originalEvent.newValue) !== chatSession) {
              return showError(WCF.Language.get('chat.error.duplicateTab'));
            }
          }
        });
      } catch (_error) {}
      if (window.Notification != null) {
        $('#timsChatNotify').click(function(event) {
          if (!$(this).data('status')) {
            return;
          }
          if (window.Notification.permission !== 'granted') {
            return window.Notification.requestPermission(function(permission) {
              var _base;
              return (_base = window.Notification).permission != null ? (_base = window.Notification).permission : _base.permission = permission;
            });
          }
        });
      }
      events.newMessage.add(notify);
      pe.refreshRoomList = new WCF.PeriodicalExecuter(refreshRoomList, 60e3);
      pe.getMessages = new WCF.PeriodicalExecuter(getMessages, v.config.reloadTime * 1e3);
      (function() {
        be.bastelstu.wcf.nodePush.onConnect(function() {
          console.log('Disabling periodic loading');
          return pe.getMessages.stop();
        });
        be.bastelstu.wcf.nodePush.onDisconnect(function() {
          console.log('Enabling periodic loading');
          getMessages();
          return pe.getMessages = new WCF.PeriodicalExecuter(getMessages, v.config.reloadTime * 1e3);
        });
        be.bastelstu.wcf.nodePush.onMessage('be.bastelstu.chat.newMessage', getMessages);
        return be.bastelstu.wcf.nodePush.onMessage('be.bastelstu.wcf.nodePush.tick60', getMessages);
      })();
      join(roomID);
      $('#timsChatInput').enable().jCounter().focus();
      console.log("Finished initializing");
      return true;
    };
    showInputError = function(message) {
      $('#timsChatInputContainer').addClass('formError').find('.innerError').show().html(message);
      if (inputErrorHidingTimer != null) {
        clearTimeout(inputErrorHidingTimer);
      }
      return inputErrorHidingTimer = setTimeout(function() {
        return hideInputError();
      }, 5e3);
    };
    hideInputError = function() {
      if (inputErrorHidingTimer != null) {
        clearTimeout(inputErrorHidingTimer);
      }
      inputErrorHidingTimer = null;
      return $('#timsChatInputContainer').removeClass('formError').find('.innerError').hide();
    };
    freeTheFish = function() {
      var fish;
      if ($.wcfIsset('fish')) {
        return;
      }
      console.warn('Freeing the fish');
      fish = $("<div id=\"fish\">" + (WCF.String.escapeHTML('><((((\u00B0>')) + "</div>");
      fish.css({
        position: 'fixed',
        top: '50%',
        left: '50%',
        color: 'black',
        textShadow: '1px 1px white',
        zIndex: 9999
      });
      fish.appendTo($('body'));
      return pe.fish = new WCF.PeriodicalExecuter(function() {
        var left, top, _ref, _ref1;
        left = Math.random() * 100 - 50;
        top = Math.random() * 100 - 50;
        fish = $('#fish');
        if (!((fish.width() < (_ref = fish.position().left + left) && _ref < ($(window).width() - fish.width())))) {
          left *= -1;
        }
        if (!((fish.height() < (_ref1 = fish.position().top + top) && _ref1 < ($(window).height() - fish.height())))) {
          top *= -1;
        }
        if (left > 0) {
          if (left > 0) {
            fish.text('><((((\u00B0>');
          }
        } else if (left < 0) {
          fish.text('<\u00B0))))><');
        }
        return fish.animate({
          top: fish.position().top + top,
          left: fish.position().left + left
        }, 1e3);
      }, 1.5e3);
    };
    getMessages = function() {
      return $.ajax(v.config.messageURL, {
        dataType: 'json',
        type: 'POST',
        success: function(data) {
          remainingFailures = 3;
          handleMessages(data.messages);
          handleUsers(data.users);
          return WCF.DOMNodeInsertedHandler.execute();
        },
        error: function() {
          console.error("Message loading failed, " + (--remainingFailures) + " remaining");
          if (remainingFailures <= 0) {
            freeTheFish();
            console.error('To many failures, aborting');
            return showError(WCF.Language.get('chat.error.onMessageLoad'));
          }
        },
        complete: function() {
          return loading = false;
        },
        beforeSend: function() {
          if (loading) {
            return false;
          }
          return loading = true;
        }
      });
    };
    handleMessages = function(messages) {
      var createNewMessage, li, message, messageContainerID, output, _i, _len, _ref;
      $('.timsChatMessageContainer.active').trigger('scroll');
      for (_i = 0, _len = messages.length; _i < _len; _i++) {
        message = messages[_i];
        message.isInPrivateChannel = (String(message.type) === v.config.messageTypes.WHISPER) && ($.wcfIsset("timsChatMessageContainer" + message.receiver) || $.wcfIsset("timsChatMessageContainer" + message.sender));
        events.newMessage.fire(message);
        createNewMessage = true;
        if ($('.timsChatMessage:last-child .text').is('ul') && lastMessage !== null && ((_ref = lastMessage.type) === 0 || _ref === 7)) {
          if (lastMessage.type === message.type && lastMessage.sender === message.sender && lastMessage.receiver === message.receiver && lastMessage.isInPrivateChannel === message.isInPrivateChannel) {
            createNewMessage = false;
          }
        }
        if (createNewMessage) {
          message.isFollowUp = false;
          output = v.messageTemplate.fetch({
            message: message,
            messageTypes: v.config.messageTypes
          });
          li = $('<li></li>');
          li.addClass('timsChatMessage');
          li.addClass("timsChatMessage" + message.type);
          li.addClass("user" + message.sender);
          if (message.sender === WCF.User.userID) {
            li.addClass('ownMessage');
          }
          li.append(output);
          if (message.isInPrivateChannel && message.sender === WCF.User.userID) {
            li.appendTo($("#timsChatMessageContainer" + message.receiver + " > ul"));
          } else if (message.isInPrivateChannel) {
            li.appendTo($("#timsChatMessageContainer" + message.sender + " > ul"));
          } else {
            li.appendTo($('#timsChatMessageContainer0 > ul'));
          }
        } else {
          message.isFollowUp = true;
          output = v.messageTemplate.fetch({
            message: message,
            messageTypes: v.config.messageTypes
          });
          if (message.isInPrivateChannel && message.sender === WCF.User.userID) {
            messageContainerID = message.receiver;
          } else if (message.isInPrivateChannel) {
            messageContainerID = message.sender;
          } else {
            messageContainerID = 0;
          }
          $("#timsChatMessageContainer" + messageContainerID + " .timsChatMessage:last-child .text").append($(output).find('.text li:last-child'));
        }
        lastMessage = message;
      }
      if ($('#timsChatAutoscroll').data('status') === 1) {
        return $('.timsChatMessageContainer.active').scrollTop($('.timsChatMessageContainer.active').prop('scrollHeight'));
      }
    };
    handleUsers = function(users) {
      var foundUsers, user, _fn, _i, _len;
      foundUsers = {};
      userList.current = {};
      _fn = function(user) {
        var element, id, li, menu;
        userList.current[user.userID] = userList.allTime[user.userID] = user;
        id = "timsChatUser" + user.userID;
        if ($.wcfIsset(id)) {
          console.log("Moving User: '" + user.username + "'");
          element = $("#" + id).detach();
          if (user.awayStatus != null) {
            element.addClass('away');
            element.attr('title', user.awayStatus);
          } else {
            element.removeClass('away');
            element.removeAttr('title');
            element.data('tooltip', '');
          }
          if (user.suspended) {
            element.addClass('suspended');
          } else {
            element.removeClass('suspended');
          }
          $('#timsChatUserList > ul').append(element);
        } else {
          console.log("Inserting User: '" + user.username + "'");
          li = $('<li></li>');
          li.attr('id', id);
          li.addClass('timsChatUser');
          li.addClass('jsTooltip');
          li.addClass('dropdown');
          if (user.userID === WCF.User.userID) {
            li.addClass('you');
          }
          if (user.suspended) {
            li.addClass('suspended');
          }
          if (user.awayStatus != null) {
            li.addClass('away');
            li.attr('title', user.awayStatus);
          }
          li.data('username', user.username);
          li.append(v.userTemplate.fetch(user));
          menu = $('<ul></ul>');
          if (user.userID !== WCF.User.userID) {
            menu.append($("<li><a>" + (WCF.Language.get('chat.general.query')) + "</a></li>").click(function() {
              return openPrivateChannel(user.userID);
            }));
            menu.append($("<li><a>" + (WCF.Language.get('chat.general.kick')) + "</a></li>"));
            menu.append($("<li><a>" + (WCF.Language.get('chat.general.ban')) + "</a></li>"));
            menu.append($("<li><a href=\"" + user.link + "\">" + (WCF.Language.get('chat.general.profile')) + "</a></li>"));
          }
          events.userMenu.fire(user, menu);
          if (menu.find('li').length) {
            li.append(menu);
            menu.addClass('dropdownMenu');
          }
          li.appendTo($('#timsChatUserList > ul'));
        }
        return foundUsers[id] = true;
      };
      for (_i = 0, _len = users.length; _i < _len; _i++) {
        user = users[_i];
        _fn(user);
      }
      $('.timsChatUser').each(function() {
        if (foundUsers[$(this).attr('id')] == null) {
          console.log("Removing User: '" + ($(this).data('username')) + "'");
          WCF.Dropdown.removeDropdown($(this).attr('id'));
          return $(this).remove();
        }
      });
      return $('#toggleUsers .badge').text($('.timsChatUser').length);
    };
    insertText = function(text, options) {
      if (options == null) {
        options = {};
      }
      options = $.extend({
        append: true,
        submit: false
      }, options);
      if (options.append) {
        text = $('#timsChatInput').val() + text;
      }
      $('#timsChatInput').val(text);
      $('#timsChatInput').keyup();
      if (options.submit) {
        return $('#timsChatForm').submit();
      } else {
        return $('#timsChatInput').focus();
      }
    };
    notify = function(message) {
      var content, privateChannelID, title, _ref;
      if (scrollUpNotifications) {
        $('.timsChatMessageContainer.active').addClass('notification');
      }
      if (message.isInPrivateChannel) {
        if (message.sender === WCF.User.userID) {
          privateChannelID = message.receiver;
        } else {
          privateChannelID = message.sender;
        }
        if ($('.timsChatMessageContainer.active').data('userID') !== privateChannelID) {
          $("#privateChannel" + privateChannelID).addClass('notify');
        }
      } else if ($('.timsChatMessageContainer.active').data('userID') !== 0) {
        $("#privateChannel0").addClass('notify');
      }
      if (isActive || $('#timsChatNotify').data('status') === 0) {
        return;
      }
      document.title = v.titleTemplate.fetch($.extend({}, currentRoom, {
        newMessageCount: ++newMessageCount
      }));
      title = WCF.Language.get('chat.general.notify.title');
      content = "" + message.username + message.separator + " " + message.message;
      if (((_ref = window.Notification) != null ? _ref.permission : void 0) === 'granted') {
        return (function() {
          var notification;
          notification = new window.Notification(title, {
            body: content,
            onclick: function() {
              return notification.close();
            }
          });
          return setTimeout(function() {
            return notification.close();
          }, 5e3);
        })();
      }
    };
    refreshRoomList = function() {
      console.log('Refreshing the roomlist');
      return new WCF.Action.Proxy({
        autoSend: true,
        data: {
          actionName: 'getRoomList',
          className: 'chat\\data\\room\\RoomAction'
        },
        showLoadingOverlay: false,
        suppressErrors: true,
        success: function(data) {
          var li, room, _i, _len, _ref, _ref1;
          $('.timsChatRoom').remove();
          $('#toggleRooms .badge').text(data.returnValues.length);
          _ref = data.returnValues;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            room = _ref[_i];
            li = $('<li></li>');
            if (room.active) {
              li.addClass('active');
            }
            $("<a href=\"" + room.link + "\">" + room.title + " <span class=\"badge\">" + (WCF.String.formatNumeric(room.userCount)) + "</span></a>").addClass('timsChatRoom').data('roomID', room.roomID).appendTo(li);
            $('#timsChatRoomList ul').append(li);
          }
          if (((_ref1 = window.history) != null ? _ref1.replaceState : void 0) != null) {
            $('.timsChatRoom').click(function(event) {
              var target;
              event.preventDefault();
              target = $(this);
              window.history.replaceState({}, '', target.attr('href'));
              join(target.data('roomID'));
              $('#timsChatRoomList .active').removeClass('active');
              return target.parent().addClass('active');
            });
          }
          return console.log("Found " + data.returnValues.length + " rooms");
        }
      });
    };
    showError = function(text) {
      var errorDialog, formSubmit, reloadButton;
      if (errorVisible) {
        return;
      }
      errorVisible = true;
      loading = true;
      pe.refreshRoomList.stop();
      pe.getMessages.stop();
      errorDialog = $("<div id=\"timsChatLoadingErrorDialog\">\n	<p>" + text + "</p>\n</div>").appendTo('body');
      formSubmit = $("<div class=\"formSubmit\"></div>").appendTo(errorDialog);
      reloadButton = $("<button class=\"buttonPrimary\">" + (WCF.Language.get('chat.error.reload')) + "</button>").appendTo(formSubmit);
      reloadButton.on('click', function() {
        return window.location.reload();
      });
      return $('#timsChatLoadingErrorDialog').wcfDialog({
        closable: false,
        title: WCF.Language.get('wcf.global.error.title')
      });
    };
    join = function(roomID) {
      loading = true;
      return new WCF.Action.Proxy({
        autoSend: true,
        data: {
          actionName: 'join',
          className: 'chat\\data\\room\\RoomAction',
          parameters: {
            roomID: roomID
          }
        },
        success: function(data) {
          loading = false;
          $('#timsChatTopic').removeClass('hidden');
          currentRoom = data.returnValues;
          currentRoom.roomID = roomID;
          $('#timsChatTopic > .topic').text(currentRoom.topic);
          if (currentRoom.topic.trim() === '') {
            $('#timsChatTopic').addClass('empty');
          } else {
            $('#timsChatTopic').removeClass('empty');
          }
          $('.timsChatMessage').addClass('unloaded');
          document.title = v.titleTemplate.fetch(currentRoom);
          handleMessages(currentRoom.messages);
          getMessages();
          return refreshRoomList();
        },
        failure: function() {
          return showError(WCF.Language.get('chat.error.join'));
        }
      });
    };
    openPrivateChannel = function(userID) {
      var avatar, div, li, span;
      userID = parseInt(userID);
      console.log("Opening private channel " + userID);
      if (!$.wcfIsset("timsChatMessageContainer" + userID)) {
        if (userList.allTime[userID] == null) {
          return;
        }
        div = $('<div>');
        div.attr('id', "timsChatMessageContainer" + userID);
        div.data('userID', userID);
        div.addClass('timsChatMessageContainer');
        div.addClass('marginTop');
        div.addClass('container');
        div.wrapInner('<ul>');
        $('#timsChatMessageContainer0').after(div);
      }
      $('.privateChannel').removeClass('active');
      if (userID !== 0) {
        $('#timsChatTopic').removeClass('hidden empty');
        $('#timsChatTopic > .topic').text(WCF.Language.get('chat.general.privateChannelTopic', {
          username: userList.allTime[userID].username
        }));
        $('#timsChatTopic > .jsTopicCloser').attr('title', WCF.Language.get('chat.general.closePrivateChannel'));
        if (!$.wcfIsset("privateChannel" + userID)) {
          li = $('<li>');
          li.attr('id', "privateChannel" + userID);
          li.data('privateChannelID', userID);
          li.addClass('privateChannel');
          span = $('<span class="userAvatar framed" />');
          avatar = $(userList.allTime[userID].avatar[16]);
          avatar.addClass('jsTooltip');
          avatar.attr('title', userList.allTime[userID].username);
          avatar.wrap(span);
          li.append(avatar.parent().addClass('small'));
          avatar = $(userList.allTime[userID].avatar[32]);
          avatar.addClass('jsTooltip');
          avatar.attr('title', userList.allTime[userID].username);
          avatar.wrap(span);
          li.append(avatar.parent().addClass('large'));
          $('#privateChannelsMenu ul').append(li);
        }
        $('#privateChannelsMenu').addClass('shown');
      } else {
        $('#timsChatTopic > .topic').text(currentRoom.topic);
        $('#timsChatTopic > .jsTopicCloser').attr('title', WCF.Language.get('chat.general.closeTopic'));
        if (currentRoom.topic.trim() === '') {
          $('#timsChatTopic').addClass('empty');
        } else {
          $('#timsChatTopic').removeClass('empty');
        }
      }
      WCF.DOMNodeInsertedHandler.execute();
      $('.timsChatMessageContainer').removeClass('active');
      $("#timsChatMessageContainer" + userID).addClass('active');
      $("#privateChannel" + userID).addClass('active').removeClass('notify');
      return openChannel = userID;
    };
    closePrivateChannel = function(userID) {
      if (userID !== 0) {
        $("#privateChannel" + userID).remove();
        $("#timsChatMessageContainer" + userID).remove();
      }
      if ($('#privateChannelsMenu li').length <= 1) {
        $('#privateChannelsMenu').removeClass('shown');
      }
      return openPrivateChannel(0);
    };
    addListener = function(event, callback) {
      if (events[event] == null) {
        return false;
      }
      events[event].add(callback);
      return true;
    };
    removeListener = function(event, callback) {
      if (events[event] == null) {
        return false;
      }
      events[event].remove(callback);
      return true;
    };
    Chat = {
      init: init,
      getMessages: getMessages,
      refreshRoomList: refreshRoomList,
      insertText: insertText,
      freeTheFish: freeTheFish,
      join: join,
      listener: {
        add: addListener,
        remove: removeListener
      }
    };
    if (window.be == null) {
      window.be = {};
    }
    if (be.bastelstu == null) {
      be.bastelstu = {};
    }
    return window.be.bastelstu.Chat = Chat;
  })(jQuery, this);

}).call(this);
